part of fenris.engine;

class GameEngine extends Engine {
    Timer timer;

    static GameEngine instance;
    CanvasElement canvas;

    factory GameEngine() {
        if (instance == null) {
            instance = new GameEngine._internal();
        }
        return instance;
    }

    GameEngine._internal() {
        this.timer = new Timer.repeating(1, this.run);
        this.canvas = new CanvasElement(width: 100, height: 100);
        
        MapEngine.instance.load("/data/map.json");
    }

    void run(Timer t) {
        if (MapEngine.instance.map != null) {
            MapEngine.instance.map.draw(this.canvas.getContext("2d"));
        }
    }
}