part of fenris.game.map;

class Layer {
    List<List<Tile>> tiles;
    Tileset tileset;

    Layer(List land, this.tileset) {
        for (int y = 0 ; y < land.length ; y++) {
            this.tiles[y] = new List();
            for (int x = 0 ; x < land[y].length ; x++) {
                this.tiles[y][x] = new Tile(land[y][x], new Position(x, y));
            }
        }
    }

    void draw(CanvasRenderingContext2D context) {
        for (List<Tile> tiles in this.tiles) {
            for (Tile tile in tiles) {
                Position tilePosition = tileset.getTilePosition(tile.value);
                context.drawImage(
                    tileset,
                    tilePosition.x, tilePosition.y,
                    tileset.tileWidth, tileset.tileHeight,
                    tile.position.x, tile.position.y,
                    tileset.tileWidth, tileset.tileHeight);
            }
        }
    }
}