part of fenris.game.map;

/**
 * A Tileset is an image of tiles.
 */
class Tileset extends HasImage {
    int tileWidth;
    int tileHeight;

    /**
     * Constructor
     */
    Tileset(String url, this.tileWidth, this.tileHeight) : super(url);
    
    Position getTilePosition(int tileNumber) {
        var xSourceEnTiles = tileNumber % this.tileWidth;
        if (xSourceEnTiles == 0) xSourceEnTiles = this.tileWidth;

        int ySourceEnTiles = (tileNumber / this.tileWidth).ceil().toInt();
        return new Position((xSourceEnTiles-1) * this.tileWidth, (ySourceEnTiles-1) * this.tileHeight);
    }
}